const bindMethod =
   (methodName = '') =>
   (instance = {}) =>
      { instance[methodName] = instance[methodName].bind(instance) }

const bindAllMethods =
   (Class = Function) =>
   (instance = {}) =>
      { let allMethodNames = Object.getOwnPropertyNames(Class.prototype)
        allMethodNames.map((methodName) => bindMethod(methodName)(instance))
      }

module.exports = bindAllMethods